]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- rel 2
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
7982022e
ER
2# vim:ts=4 sw=4 noet ft=spec
3#
f51bfb2f
ER
4# PLD Linux rpm macros.
5# <http://www.pld-linux.org/>
d54662bf 6
2b05614d 7# can be used by builder script to check for version
98c5c988
ER
8%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
9
e05017c1 10%epoch 0
3241033b 11%x8664 x86_64 amd64 ia32e
e483e029 12%arm armv3l armv4b armv4l armv5teb armv5tel
9c404149 13
ba1fdedc 14# kernel compiler
345d14e5 15%kgcc %{__cc}
d2e1bc22 16%kgcc_package gcc
ba1fdedc 17
46763914 18# compiler version
eab5f7f4
ER
19%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
20%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
46763914 21
69bcfbf3 22%__rm /bin/rm --interactive=never
36eccf0d 23
33040789 24# Build system path macros.
69bcfbf3
ER
25%__autoconf autoconf %{?debug:-Wall}
26%__automake automake -a -c -f --foreign
27%__autopoint autopoint --force
28
29# add parallel build flags: -jN
a5656a95 30#
11ecb0a1
ER
31# if you want to disable parallel build do:
32# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 33#
11ecb0a1
ER
34%__make /usr/bin/make %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 37%__cmake /usr/bin/cmake
a5656a95
JR
38
39%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
40 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 41
83094b62 42%__gettextize { \
8a995cff 43 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 44 gettextize --copy --force --no-changelog; \
97589b6e 45 else \
3241033b 46 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
47 fi; \
48 if [ ! -f po/Makevars ]; then \
3241033b 49 cp -f po/Makevars{.template,}; \
8a995cff 50 fi; \
8a995cff 51}
f93109a0 52
53%__glib_gettextize glib-gettextize --copy --force
54%__gnome_doc_common gnome-doc-common --copy
fb59e475 55%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 56%__gtkdocize gtkdocize --copy
57%__intltoolize intltoolize --copy --force
c26f1b59 58%__libtoolize libtoolize --copy --force --install
33040789 59
751c2bdd
ER
60# topdir is where builder script lives,
61# fallback to old style if SPECS/SOURCES dirs were found.
62%_topdir %{expand:%%global _topdir %(
63 if [ -d SPECS -a -d SOURCES ]; then
64 # old style rpmdir: in topdir
df3151c2 65 pwd
751c2bdd
ER
66 elif [ -d ../SPECS -a -d ../SOURCES ]; then
67 # old style rpmdir: in subdir
df3151c2 68 cd ..; pwd
751c2bdd
ER
69 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
70 # if old style rpm dir exist, go with it
71 echo $HOME/rpm; \
72 elif [ -x ../builder -a ! -d ../builder ]; then
73 # relative new style rpmdir: in package dir
df3151c2 74 cd ..; pwd
751c2bdd
ER
75 elif [ -x builder -a ! -d builder ]; then
76 # relative new style rpmdir: in packages
df3151c2 77 pwd
751c2bdd
ER
78 elif [ -x packages/builder -a ! -d packages/builder ]; then
79 # relative new style rpmdir: packages dir in current dir
df3151c2 80 cd packages; pwd
751c2bdd
ER
81 else
82 # fallback to new style rpmdir
83 echo $HOME/rpm/packages
84 fi; \
85)}%_topdir
1052b4b8 86
751c2bdd
ER
87# if %{_topdir}/SPECS exists, it's old style structure
88%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
89%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8
ER
90
91# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
92# if they don't exist assume we are having custom topdir (which is not named as
93# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
df3151c2
ER
94# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
95%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
96%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
97%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 98
81e450f7
ER
99# The number of cvs changelog entries kept when building package.
100%_buildchangelogtruncate 20
101
6a5eda77 102%dependencytracking %{nil}
3241033b 103
e5da9169
ER
104# Relations between package names that cause dependency loops
105# with legacy packages that cannot be fixed. Relations are
106# specified as
107# p>q
108# where package p has a Requires: on something that package q Provides:
109#
110# XXX Note: that there cannot be any whitespace within the string "p>q",
111# and that both p and q are package names (i.e. no version/release).
112%_dependency_whiteout %{nil}
113
810fa5c4 114#-----------------------------------------------------------------
115#
116# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
117# BuildRequires: awk
118# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 119#
120# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 121# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
122# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 123# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 124# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 125#
126# Regular expressions are supported, but to avoid some character be treated
127# as regular expression it must be escaped twice.
128
129%filter_out \
7b6f1112 130 for (i = 1; i in I; i++) { A=0; \
810fa5c4 131 for (f in F) { \
132 if (I[i] ~ "^" F[f] "$") A=1; \
133 }; \
134 if (!A) printf(I[i] FS); \
135 }
136
137%rpmcflags %(awk 'BEGIN {
138 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 139 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 140 %{filter_out}
141}')
142
143%rpmcxxflags %(awk 'BEGIN {
09a90176 144 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
145 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 146 %{filter_out}
147}')
148
98e7f050
AM
149%rpmcppflags %(awk 'BEGIN {
150 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
151 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
152 %{filter_out}
153}')
154
810fa5c4 155%rpmldflags %(awk 'BEGIN {
c05a0741 156 split("%{?optldflags}",I);
810fa5c4 157 split("%{?filterout_ld}",F)
158 %{filter_out}
159}')
160
25f52d1a 161# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
162# but, don't use it, better use gcc as linker
163%ld_rpmldflags %(awk 'BEGIN {
164 split("%{rpmldflags}",F);
165 for (f in F) {
166 s = F[f];
167 if (s ~ /^-Wl,/) {
168 s = substr(s,5);
169 gsub(/,/," ",s);
170 };
171 printf(s FS);
172 };
173}')
174
8ef644e5 175#-----------------------------------------------------------------
176#
177# Generate a command which cleans environment, leaving only the
178# most important variables.
179# If any spec requires any additional environment it should
180# redefine %_preserve_env in following manner:
181#
182# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 183# %define _preserve_env ADDITIONAL_VAR
8ef644e5 184
57ba0f59 185%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 186
bb597f2b
AM
187# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
188%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 189 split("%{?_preserve_env}", P);
a363d727
ER
190 for (i in P) {
191 p = P[i];
82d10503
ER
192 if (!ENVIRON[p] || d[p]) {
193 continue;
8ef644e5 194 }
82d10503
ER
195 d[p] = 1;
196 split(ENVIRON[p], V, "");
197 val = p "=";
198 for (j = 1; j in V; j++) {
199 v = V[j];
200 if (v == q)
201 v = qq;
202 else if (v == "\\"")
203 v = q2q;
204 else if (v == "\\\\")
205 v = "\\\\\\\\";
206 else
207 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
208 val = val "" v;
209 }
210 printf(val " ");
8ef644e5 211 }
212}')
213
9c404149 214#-----------------------------------------------------------------
9f4ce098 215%configure2_13 { \
9c404149
AM
216 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
217 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
218 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 219 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 220 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 221 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 222 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
223 %{?__cc:CC="%{__cc}" ; export CC ; } \
224 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 225 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 226 --host=%{_target_platform} \
9c404149
AM
227 --prefix=%{_prefix} \
228 --exec-prefix=%{_exec_prefix} \
229 --bindir=%{_bindir} \
230 --sbindir=%{_sbindir} \
231 --sysconfdir=%{_sysconfdir} \
232 --datadir=%{_datadir} \
233 --includedir=%{_includedir} \
234 --libdir=%{_libdir} \
235 --libexecdir=%{_libexecdir} \
236 --localstatedir=%{_localstatedir} \
237 --sharedstatedir=%{_sharedstatedir} \
238 --mandir=%{_mandir} \
239 --infodir=%{_infodir} \
b6c5da52 240 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 241 %{dependencytracking} \
9c404149
AM
242}
243
c4a85bd8 244%cmake \
d41caea6
ER
245%{?__cc:CC="%{__cc}"} \\\
246%{?__cxx:CXX="%{__cxx}"} \\\
247CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
248CFLAGS="${CFLAGS:-%{rpmcflags}}" \\\
249FFLAGS="${FFLAGS:-%{rpmcflags}}" \\\
250FCFLAGS="${FCFLAGS:-%{rpmcflags}}" \\\
251CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \\\
252LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \\\
c4a85bd8 253%{__cmake} \\\
8736ae44 254 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
c4a85bd8 255 -DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \\\
8736ae44
ER
256 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
257 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
258 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
259 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
260 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
261 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
f0f62f9d 262 -DCMAKE_CXX_FLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \\\
974b0204
ER
263 -DCMAKE_CPP_FLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
264 -DCMAKE_C_FLAGS="${CFLAGS:-%{rpmcflags}}" \\\
c27b3ff8 265%if "%{_lib}" == "lib64" \
c4a85bd8 266 -DLIB_SUFFIX=64 \\\
9d1e0c01 267%endif \
8736ae44 268 -DBUILD_SHARED_LIBS:BOOL=ON \\\
c4a85bd8 269%{nil}
89f4ca1f 270
89f4ca1f
ER
271%scons { \
272%{__scons} \
5c76736d
ER
273 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
274 CFLAGS="${CFLAGS:-%rpmcflags}" \
275 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
276 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 277 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
278 %{?__cc:CC="%{__cc}"} \
279 %{?__cxx:CXX="%{__cxx}"} \
280 libsuffix=%{_lib} \
281 prefix=%{_prefix} \
39b9534b
ER
282}
283
6339d32d 284# waf. see waf.spec
6339d32d 285%waf { \
6339d32d
ER
286CC="%{__cc}" \
287CXX="%{__cxx}" \
9e244007 288CPP="%{__cpp}" \
6339d32d
ER
289CFLAGS="%{rpmcflags}" \
290CXXFLAGS="%{rpmcxxflags}" \
291%{__waf} \
6339d32d
ER
292}
293
4a6b0d54 294#----------------------------------------------------------------
9bacbb5b 295#%configure_cache 0
fe6c4bdd 296%configure_cache_file %{buildroot}.configure.cache
73f832b3 297
e84cd836 298%configure {./configure \
4a6b0d54
AF
299 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
300 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 301 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 302 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 303 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 304 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
305 %{?__cc:CC="%{__cc}"} \
306 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 307 --host=%{_target_platform} \
4a6b0d54
AF
308 --build=%{_target_platform} \
309 --prefix=%{_prefix} \
310 --exec-prefix=%{_exec_prefix} \
311 --bindir=%{_bindir} \
312 --sbindir=%{_sbindir} \
313 --sysconfdir=%{_sysconfdir} \
314 --datadir=%{_datadir} \
315 --includedir=%{_includedir} \
316 --libdir=%{_libdir} \
317 --libexecdir=%{_libexecdir} \
318 --localstatedir=%{_localstatedir} \
319 --sharedstatedir=%{_sharedstatedir} \
320 --mandir=%{_mandir} \
321 --infodir=%{_infodir} \
b6c5da52 322 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 323 %{dependencytracking} \
9bacbb5b 324 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
325}
326
611a25d5 327# Simple macros to simplify adding bconded options to configure scripts.
328# Each macro requires bcond name and accepts optional option name, if option
329# isn't specified bcond name is used as option name. Options returning
330# --with and --enable also allow third argument which will be added as value
331# ( --with-option=value or --enable-option=value ) in case or positive
332# condition, but won't be added otherwise ( nothing or just --disable-option ).
333
334# Requirements:
335# BuildRequires: rpmbuild(macros) >= 1.527
336
337# Usage example:
338# %{__enable bcond} - returns --enable-bcond iff build condition is set
339# %{__disable bcond option} - returns --enable-option iff bcond is not set
340# %{__enable_disable bcond option value} - returns --enable-option=value if
341# bcond is set, returns --disable-option otherwise
342
343# expand bconds to --enable-something and --disable-something
344%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
345%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
346%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
347
348# same as above, but condition inverted
349%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
350%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
351%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
352
353# expand bconds to --with-something and --without-something
354%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
355%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
356%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
357
358# same as above, but condition inverted
359%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
360%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
361%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
362
363#-----------------------------------------------------------------
364
b3b1397b
ER
365# overload to insert debuginfo package
366%prep \
367%if 0%{?_enable_debug_packages}\
368%{debug_package}\
369%endif\
370%%prep\
371%{nil}
372
9c404149 373# Location of autoconf macros
ef7d5e14 374%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
9c404149 375
e2804f99 376# Location of omf files
7f0f4a79 377%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 378
e987a186 379# Location of pkgconfig files
9a4e877a 380%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
381# noarch pkgconfig files
382%_npkgconfigdir /usr/share/pkgconfig
e987a186 383
486b0b5f 384# Location of desktop files
385%_desktopdir /usr/share/applications
86dff2d0 386%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 387
481463e9 388# Location of pixmaps for applnk/desktop files
e1f0a822 389%_pixmapsdir /usr/share/pixmaps
9c404149 390
481463e9 391# Location of themable icons for applnk/desktop files
b36c8e2a 392%_iconsdir /usr/share/icons
393
e987a186
JB
394# Location of fonts directories
395%_fontsdir /usr/share/fonts
396
b3282f3f 397# Location of Gtk and associated libraries documentation
fe6c4bdd 398%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 399
fc4d7771 400# Location of KDE documentation
fe6c4bdd 401%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 402
5869828c 403# unsermake script
404%__unsermake /usr/share/unsermake/unsermake
405
9c404149 406# Current date
8cf161e2 407%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 408
9c404149
AM
409# Example files, programs, scripts...
410%_examplesdir /usr/src/examples
411
c8f7e820 412# Alternative kernel type/version
261729d9 413%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 414
8377d27d 415# The directory holding Linux kernel sources
261729d9 416%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 417
c0fe61f0
ER
418# SysV-style initscripts dir
419%_initddir /etc/rc.d/init.d
420
9c404149 421# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 422%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 423
590bc1db 424# Bootstrap release macros.
425# Usage:
426# %bcond_with bootstrap
427# Release: %{bootstrap_release 1}
428#
429# Package will have release 1 if built normally,
430# and release 0.zzz.bootstrap if built with bootstrap
431%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
432
c924d9d8
ER
433# -n drm to generate kernel%{_alt_kernel}-drm dependency
434%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
435%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
436%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 437
c924d9d8 438# -s post to generate Requires(post) dependency
63d9963a
ER
439%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
440%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
441%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 442
410df6e8
ER
443# Requires name = version-release
444%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 445# Requires: name = version
91d2f1eb 446%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 447# Requires: name = version (version based on querying package %2)
0d3e64c0 448%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 449
90c674d3
JR
450# Requires: name >= version
451%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
452# Requires: name >= version (version based on querying package %2)
453%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
454
c94807f3 455%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 456
457# kernel version-release handling
95125403 458%__kernel_ver %{expand:%%global __kernel_ver %( \\
acac3049 459 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
95125403
ER
460 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
461 echo ${Z:-ERROR}; \\
1a7d3518 462)}%__kernel_ver
95125403 463
c94807f3
ER
464%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
465%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
466%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
467%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 468
6262f001
ER
469# `uname -r` to be used in @release field
470%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
471
e00dd7f6 472# sgml macros
3241033b
ER
473%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
474%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
475%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
476%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
477%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
478%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 479%docbook_sgmlcat_fix() { for l in \
480'' \
481' -- default decl --' \
482'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
483' -- hacks for opensp --' \
484'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
485'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
486'' \
487; do echo $l; done >> %1 \
488}
489
eea64748
ER
490# vim - "
491
4f044018
ER
492# minimum file size needed for compressed documents.
493# just smaller files than this get larger when compressed.
a88ae20f
ER
494# some stats:
495# - 0 byte file compressed was 25 bytes .gz
496# - 39 byte file was compressed as 57
497# - with test/test.spec@man 158 byte file was compressed also 158
498%_min_compress_bytes 159
4f044018 499
9c404149
AM
500#-----------------------------------------------------------------
501# find and gzip all files in %{_mandir} and %{infodir}
502#
503# Requires: xargs, find
504#
505#%no_install_post_compress_docs 1
506%__spec_install_post_compress_docs { \
53d5af13 507%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 508 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 509 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 510 echo "Compress man pages: $i"; \
4f044018
ER
511 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
512 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
513 find $RPM_BUILD_ROOT$i -type l | while read a; do \
514 m=$(readlink $a); \
515 rm -f $a; \
516 echo .so ${m##*/} > $a; \
517 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
518 done; \
4f044018 519 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
520 fi; \
521 done; \
728ad671
JB
522 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
523 echo "Compress info pages: %{_infodir}"; \
524 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
525 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
526 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 527 fi; \
53d5af13 528}; __spec_install_post_compress_docs } }
9c404149
AM
529
530#-----------------------------------------------------------------
531# Strip executable binaries and shared object files
532#
533# Requires: find, awk, strip, cut, xargs
534#
a2ad2754
JB
535# Special macros which affect this process:
536#%no_install_post_strip 1 # disable stripping at all
537#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
538#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
539#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
540#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
541#
9c404149 542%__spec_install_post_strip {%{!?debug: \
53d5af13 543%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 544if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
545 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
546 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
547 if [ "$modulelist" ]; then \
548 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 549 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
550 echo "$modulelist" | xargs -l512 chmod u+w; \
551 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
552 echo "DONE"; \
553 fi; \
eea64748 554 fi; \
0ac49134 555 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
556 if [ -n "$filelist" ]; then \
557 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
558 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
559 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 560 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 561 if [ -n "$elfexelist" ]; then \
4d5370ac 562 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
563 chmod u+w $elfexelist; \
564 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
565 echo "DONE"; \
566 fi; \
567 if [ -n "$elfsharedlist" ]; then \
4d5370ac 568 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
569 chmod u+w $elfsharedlist; \
570 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
571 echo "DONE"; \
572 fi; \
573 if [ -n "$archiveslist" ]; then \
4d5370ac 574 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
575 chmod u+w $archiveslist; \
576 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
577 echo "DONE"; \
578 fi; \
98a06bad 579 fi; \
0ac49134
ER
580 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
581 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
582 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 583 if [ -n "$filelist_all" ]; then \
4d5370ac 584 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 585 chmod u+w $filelist_all; \
f89ccb5f 586 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 587 echo "DONE"; \
9c404149 588 fi; \
f89ccb5f 589 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 590 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 591 chmod u+w $filelist_unneeded; \
f89ccb5f 592 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 593 echo "DONE"; \
8f74418b 594 fi; \
f89ccb5f 595 if [ -n "$filelist_debug" ]; then \
4d5370ac 596 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 597 chmod u+w $filelist_debug; \
f89ccb5f 598 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 599 echo "DONE"; \
9f0d4f36 600 fi; \
53d5af13 601fi; }; __spec_install_post_strip } } }
3241033b 602
fc5d7e20 603#-----------------------------------------------------------------
604# remove all RPATH from executable binaries and shared object files
605#
606# Requires: find, awk, cut, xargs, chrpath, uname
607#
a2ad2754
JB
608# Special macros which affect this process
609#%no_install_post_chrpath 1 # disable chrpath at all
610#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
611#
fc5d7e20 612%__spec_install_post_chrpath {%{!?debug: \
53d5af13 613%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 614if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 615 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 616 if [ -n "$files" ]; then \
d5517264 617 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 618 fi; \
98a06bad 619 if [ -n "$objs" ]; then \
4d5370ac 620 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
621 echo "$objs" | \
622 while read file; do \
623 rpath= ; \
624 chmod u+w "$file"; \
5541bf26 625 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
626 case $dir in \
627 '$ORIGIN' ) \
628 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
629 else rpath="$rpath:$dir" ; fi ; \
630 continue ; \
631 ;; \
632 esac ; \
f9abaddb
AM
633 newdir=$(readlink -m "$dir"); \
634 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
635 case $dir in \
636 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
637 echo "remove-rpath: $dir in $file"; \
638 ;; \
639 * ) \
640 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
641 else rpath="$rpath:$dir" ; fi ; \
642 ;; \
643 esac ; \
644 done ; \
645 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
646 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
647 done; \
648 fi; \
53d5af13 649fi; }; __spec_install_post_chrpath } } }
3241033b 650
611a25d5 651# vim: "
652
d366d7e0
AM
653#-----------------------------------------------------------------
654# Find all shared object files with unresolved symbols. Warn
655# and terminate if any found (termination can be turned off by define).
656#%no_install_post_check_so 1
ff8c88f6 657#%skip_post_check_so libwithunresolvedok.so.*
e067aec9 658#
659# NOTE: define skip_post_check_so only if such library really requires
660# unresolved symbols and always leave a comment why it is required:
661# # executable provides symbols foo, bar for those libraries:
662# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
663#
d366d7e0 664%__spec_install_post_check_so { \
229037b6
ER
665__spec_install_post_check_so() { \
666 fail=0; \
667 printf "Searching for shared objects with unresolved symbols..."; \
668 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
669 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
670 done ; \
671 echo " DONE"; \
672 %{!?no_install_post_check_so:return $fail;} \
d366d7e0
AM
673}; __spec_install_post_check_so }}
674
d72c185f 675#-----------------------------------------------------------------
ccb8ae8d 676# Find and gzip all kernel modules
677#
678# Requires: find
679#
fe6c4bdd 680#%no_install_post_compress_modules 1
ccb8ae8d 681%__spec_install_post_compress_modules { \
53d5af13 682%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 683 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 684 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
685 if [ "$q" ]; then \
686 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
687 echo "$q" | xargs -r %{__gzip} -9nf; \
688 echo "DONE"; \
689 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
690 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
691 fi; \
3241033b 692 fi; \
53d5af13 693}; __spec_install_post_compress_modules } }
9c404149 694
ef64802f
ER
695# Remove common Perl files we don't package
696%__spec_install_post_perl_clean {\
697%{!?no_install_post_perl_clean: \
698%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
699} }
700
83094b62 701#-----------------------------------------------------------------
0e4cb4dd 702# Update GConf2 schemas
83094b62 703#
704# Requires: GConf2
705#
46885239 706%gconf_schema_install() \
307ac6c9
ER
707 umask 022; \
708 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
709 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 710%{nil}
46885239 711
712%gconf_schema_uninstall() \
24336a54 713if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 714 umask 022; \
24336a54
ER
715 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
716 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 717fi; \
f93109a0 718%{nil}
719
720#-----------------------------------------------------------------
721# Update desktop MIME database
c0a4caa0 722# requires: desktop-file-utils
c3bcd10e 723%update_desktop_database() {{ \
f93109a0 724 umask 022; \
fb59e475 725 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
726};} \
727%{nil}
f93109a0 728
c3bcd10e
ER
729%update_desktop_database_post %update_desktop_database
730
731%update_desktop_database_postun() {{ \
f27cf2fd 732if [ "$1" = "0" ]; then \
c00bf95c 733 %update_desktop_database \
f27cf2fd 734fi; \
c00bf95c
MB
735};} \
736%{nil}
f93109a0 737
fb59e475 738#-----------------------------------------------------------------
739# Update shared MIME info database
740# requires: shared-mime-info
741#
c3bcd10e 742%update_mime_database() {{ \
fb59e475 743 umask 022; \
744 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
745};} \
746%{nil}
fb59e475 747
748#-----------------------------------------------------------------
749# Update icon cache
d1a9e779
ER
750# BuildRequires: rpmbuild(macros) >= 1.596
751# Requires: hicolor-icon-theme
fb59e475 752#
c3bcd10e 753%update_icon_cache() {{ \
9639d726
ER
754 %{!?1:%{error:%{0}: Required theme name missing}} \
755 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
756 umask 022; \
757 touch --no-create %{_iconsdir}/%1; \
758 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
759 fi; \
c00bf95c
MB
760};} \
761%{nil}
fb59e475 762
f93109a0 763#-----------------------------------------------------------------
764# Update scrollkeeper database
765# requires: scrollkeeper
766#
767%scrollkeeper_update_post() \
f93109a0 768 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 769%{nil}
f93109a0 770
771%scrollkeeper_update_postun() \
f27cf2fd 772if [ "$1" = "0" ]; then \
f93109a0 773 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 774fi; \
f93109a0 775%{nil}
776
c9704b95
MB
777#-----------------------------------------------------------------
778# Compile GSettings schemas
779# requires: glib2 >= 1:2.26.0
780#
781%glib_compile_schemas() {{ \
782 umask 022; \
783 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
784};} \
785%{nil}
786
9c404149
AM
787#-----------------------------------------------------------------
788# post %install sequence:
789# - autodeps exceptions
790# - compress all man and info pages,
791# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 792# - compress kernel modules if any
9c404149
AM
793
794###################################################################
795# Requires/Provides automation
3e202b06 796# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 797#
2892b5df
JB
798%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
799%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
800%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
801%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
802%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 803
338726a6
JB
804#%_noautocompressdoc %{nil}
805#
8f74418b
MM
806%_missing_doc_files_terminate_build 1%{nil}
807%_unpackaged_files_terminate_build %{nil}
8781dc74 808# (X)emacs support
d77dcb61 809%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
810%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
811%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 812
02b58f60
JK
813%__php_provides %{nil}
814%__php_requires %{nil}
815%__perl_provides %{nil}
816%__perl_requires %{nil}
fa3497cd 817%__mono_provides %{nil}
818%__mono_requires %{nil}
25043cd4
AF
819
820# Perl specific macro definitions.
c94807f3
ER
821%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
822%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
823%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
824%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
825%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
826%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 827
45c00b39 828# Ruby
c94807f3
ER
829%__ruby /usr/bin/ruby
830%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
831%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
832%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
833%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
834%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
835%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
836%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 837%ruby_rdocdir /usr/share/rdoc
c94807f3 838%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
839%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
840%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 841
7ccf7643 842%php_pear_dir /usr/share/pear
7813c433 843%php_data_dir /usr/share/php
c94807f3
ER
844%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
845%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
846%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 847
0c5d1b9b 848# extract php/zend api versions
c94807f3 849%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 850%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
851%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
852%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
853%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
854%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
855%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
d9ca5910
ER
856%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
857# "_ts" if ZTS enabled, empty otherwise
858%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
c1b2705c
ER
859
860# helper macro
f952c0f3 861%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
862
863# macros for public use
864# for php extensions (php-pecl)
68b68193 865%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 866%{__php_api_requires zend_module_api} \
f952c0f3 867%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 868%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
68b68193 869
c1b2705c
ER
870# for zend extensions
871%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 872%{__php_api_requires zend_extension_api} \
f952c0f3 873%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 874%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
c1b2705c 875
934c685f
ER
876# for php pdo modules (php-pecl-PDO_*)
877%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
878
6c3b8203
ER
879# for using PHP post scripts. for PHP >= 5.0
880%php_webserver_restart \
881[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 882[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 883if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
884 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
885 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
886 %service -q php-fcgi restart \
887 fi \
888fi \
8e2cfc36
ER
889if [ -x /etc/rc.d/init.d/php-fpm ]; then \
890 %service -q php-fpm restart \
891fi \
6c3b8203
ER
892%{nil}
893
894# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
895%php4_webserver_restart \
896[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 897[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 898if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
899 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
900 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
901 %service -q php-fcgi restart \
902 fi \
903fi \
6c3b8203
ER
904%{nil}
905
578e9248 906# X.org helper macros
434ab5a2
ER
907%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
908%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
909
c94807f3
ER
910%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
911%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
912%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
913%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
914%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 915# vim: '
578e9248 916
434ab5a2 917%requires_xorg_xserver_extension \
97486460
AM
918%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
919%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
920%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
921%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
922%{nil}
923
924%requires_xorg_xserver_xinput \
97486460
AM
925%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
926%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
927%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
928%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
929%{nil}
930
931%requires_xorg_xserver_font \
97486460
AM
932%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
933%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
934%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
935%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
936%{nil}
937
938%requires_xorg_xserver_videodrv \
97486460
AM
939%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
940%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
941%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
942%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 943%{nil}
578e9248 944
15d7cc4a
ER
945# TCL specific macro definitions.
946# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
947%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
948%tcl_sitearch %{_libdir}/tcl%{tcl_version}
949%tcl_sitelib %{_datadir}/tcl%{tcl_version}
950
25043cd4
AF
951# Python specific macro definitions.
952# python main version
2383a9da 953%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
954
955# directories
2383a9da 956%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 957%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 958%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 959%py_incdir /usr/include/python%{py_ver}
7ccf7643 960%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 961%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 962%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
963
964# pure python modules compilation
3241033b 965%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 966
3241033b 967%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
968
969# Software written in Python language require Python with main version
e63cd81d 970%pyrequires_eq() Requires: %1
25043cd4 971
4bf34b55
AF
972# Python 3.x
973# python main version
e9f00395 974%__python3 python3
4bf34b55
AF
975%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
976
977# directories
978%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
979%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
980%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
981%py3_incdir /usr/include/python%{py3_ver}
982%py3_sitedir %{py3_libdir}/site-packages
983%py3_sitescriptdir %{py3_scriptdir}/site-packages
984%py3_dyndir %{py3_libdir}/lib-dynload
985
986# pure python modules compilation
987%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
988
989%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
990
f12c2314 991# Hardlink binary identical .pyc and .pyo files
f12c2314 992%__spec_install_post_py_hardlink {\
53d5af13 993%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
994local a b c=0 t=0; \
995if [ -d "$RPM_BUILD_ROOT" ]; then \
996 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
997 while read a; do \
998 b="${a%.pyc}.pyo"; \
999 if cmp -s "$a" "$b"; then \
1000 ln -f "$a" "$b"; \
1001 c=$((c + 1)); \
1002 fi; \
1003 t=$((t + 1)); \
1004 done < __rpm_pyc; \
1005 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1006 rm -f __rpm_pyc; \
1007fi; \
53d5af13 1008}; __spec_install_post_py_hardlink } }
f12c2314 1009
9227b3f9 1010# remove python sources, so that check-files won't complain
f12c2314 1011%py_postclean() \
0f82e280 1012for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 1013 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
1014done \
1015%{nil}
1016
4bf34b55
AF
1017%py3_postclean() \
1018for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
1019 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1020done \
1021%{nil}
1022
0fc5cff8 1023# depmod macro
1024%depmod() { \
f6148427 1025umask 022; \
0fc5cff8 1026if [ -e /boot/System.map-%1 ]; then \
3241033b 1027 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 1028else \
3241033b
ER
1029 if [ -e /boot/System.map ]; then \
1030 /sbin/depmod -a -F /boot/System.map %1; \
1031 else \
1032 /sbin/depmod -a %1; \
1033 fi \
0fc5cff8 1034fi; \
1035}
1036
2afc6e64 1037# XMMS specific macros
c94807f3
ER
1038%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1039%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1040%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1041%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1042%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1043%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1044%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1045%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1046%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1047%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1048
eb41c1ce 1049%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
d1537778 1050
848c0d68 1051# user/group checking macros
1052#
1053# Usage:
1054# %userremove myuser
1055#
1056%userremove /usr/lib/rpm/user_group.sh user del
1057%groupremove /usr/lib/rpm/user_group.sh group del
1058#
1059# Usage:
1060# if %usertestrm myuser; then
1061# /usr/sbin/userdel -r myuser
1062# Note:
1063# use these macros only if you need to call userdel/groupdel with
1064# a non-standard option or take an extra action; otherwise use the
1065# %userremove/%groupremove macros
1066#
1067%usertestrm /usr/lib/rpm/user_group.sh user testrm
1068%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1069# user group membership management macros
1070#
1071# Usage:
efbc7726 1072# %addusertogroup [-q] myuser agroup
08d9b1f6 1073#
efbc7726
ER
1074# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1075#
1076# Requirements:
1077# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1078%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1079%{nil}
72fcfcb3 1080
1081# banner support (useful in {pre,post}{,un} and triggers)
1082#
1083# Usage:
908f5713 1084# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
72fcfcb3 1085# the banner text, the banner text
aa41c920
ER
1086# the banner text, and following line
1087#EOF
1088# You can use any form of here-document, <<'EOF' <<-EOT will do.
1089# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1090#
72fcfcb3 1091# -a - append to the banner
a8b9562a 1092# -e - send to stderr instead of stdout
628754cb 1093# -n - no show banner (overrides -t)
1094# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
908f5713 1095# -o - show only once, i.e when package is installed for the first time
276a7b45
ER
1096#
1097# Tests:
1098# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
908f5713
ER
1099# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1100# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
276a7b45 1101# rpm -E 'date | %banner -e banner' > m; sh -x m
908f5713 1102# rpm -E 'date | %banner -o -e banner' > m; sh -x m
276a7b45 1103#
908f5713 1104%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1b334fe4 1105RPM_SCRIPTVERBOSITY=5 \
1106[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1107if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1108 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1109else \
a8b9562a 1110 CMD="cat%{-e: >&2}" \
1b334fe4 1111fi \
908f5713 1112eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
276a7b45 1113%{nil}
628754cb 1114
990bd03f 1115# useradd/groupadd macros
4c73bc69 1116# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1117#
1118# Usage:
1119# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1120# [-g initial_group] [-G group[,...]] login
1121#
1122# -u uid. REQUIRED
1123# -g gid/group. REQUIRED
1124# -s defaults to /bin/false
1125# -d defaults to /usr/share/empty
1126# -c No default
1127# -r is accepted but ignored (it's always set)
6bd4c218 1128# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1129# rpm specific flags
1130# -P package name. defaults to %{name}
1131#
90627280 1132%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1133%{!-u:%{error:useradd: Required argument -u missing}} \
1134%{!-g:%{error:useradd: Required argument -g missing}} \
1135%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1136if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1137 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1138 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1139 exit 1 \
1140 fi \
1141else \
1142 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1143 /usr/sbin/useradd \\\
b5a7d552 1144 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1145 -u %{-u*} \\\
1146 -r \\\
1147 -d %{-d*}%{!-d:/usr/share/empty} \\\
1148 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1149 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1150 -g %{-g*} \\\
1151 %{-M} \\\
1152 %{-G:-G %{-G*}} \\\
1aac682a 1153 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1154 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1155fi;
611a25d5 1156# vim: "
90627280 1157
90627280
ER
1158# Usage:
1159# %groupadd [-P package] [-g gid] group
1160#
1161# -g gid. REQUIRED
1162#
1163# Sample:
1164# %groupadd -P %{name}-base -g %{gid} %{name}
1165
1166%groupadd(g:P:rfo) \
9ba02ba9
ER
1167%{!-g:%{error:groupadd: Required argument -g missing}} \
1168%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1169if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1170 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1171 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1172 exit 1 \
1173 fi \
1174else \
1175 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1176 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1177 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1178fi;
7cb77741 1179
7c50f037 1180# webapp macros
4c73bc69 1181# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1182#
1183# The config is installed/removed inside trigger, this means that you can any
1184# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1185# updated. if you don't need the config for various reason for specific
35663282
ER
1186# webserver, just remove the symlink from config directory using webapp
1187# program. the trigger will not recreate the symlink on upgrades. In other
1188# words the config is linked to webserver config directory on first install of
1189# PACKAGE or WEBSERVER.
1190#
7c50f037
ER
1191# Add package's webserver config to webserver webapps dir.
1192# Usage:
aea687a7 1193# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1194#
aea687a7 1195%webapp_register(f) \
35663282 1196%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1197if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1198 /usr/sbin/webapp register %1 %2\
1199fi\
694a8f2e 1200# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1201if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1202 %{expand:%service -q %%1 reload}\
35663282
ER
1203fi\
1204%{nil}
1205
1206# Remove package's config from webserver webapps dir.
35663282 1207# Usage:
531c0efc
ER
1208# %webapp_register [-f] WEBSERVER WEBAPP
1209%webapp_unregister(f) \
35663282
ER
1210%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1211# remove link if either of the packages are gone \
5d3a09a3 1212if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1213 /usr/sbin/webapp unregister %1 %2\
16897aea 1214 %{expand:%service -q %%1 reload}\
35663282
ER
1215fi \
1216%{nil}
1217
462b26fa 1218# service macro.
4c73bc69 1219# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1220#
1221# calls usual service restart on package %post, but skips the restart if
1222# administrator has disabled automatic service restarts in either global
1223# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1224#
462b26fa 1225# Usage:
7377b5ca 1226# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1227#
a0bbe604 1228# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1229# -n NOOP mode, do not actually restart service
462b26fa 1230#
7377b5ca
ER
1231# Requirements:
1232# BuildRequires: rpmbuild(macros) >= 1.268
1233# Requires: rc-scripts
1234# -n option:
1235# BuildRequires: rpmbuild(macros) >= 1.450
1236%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1237
1238
f9aa75bf
ER
1239# Java macros. based on jpackage macros.java
1240#
1241# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1242%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1243
1244# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1245%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1246
1247# Root directory for all Java VM/SDK/JRE's private things.
1248%_jvmprivdir %{_libdir}/jvm-private
1249
1250# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1251%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1252
1253# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1254%_jvmdatadir %{_datadir}/jvm
1255
1256# Root directory for all configurations parts of Java VM/SDK/JRE's
1257%_jvmsysconfdir %{_sysconfdir}/jvm
1258
1259# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1260%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1261
1262# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1263%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1264
1265# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1266%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1267
1268# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1269%_jnidir %{_libdir}/java
f9aa75bf 1270
ed644e79
JK
1271
1272# JDK selection. Set this to name of the JDK implementation to use
1273# insead of the system default
1274#%use_jdk icedtea6
1275
1276# expands to the value with right jdk for BuildRequires header
1277# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1278# The requirement will not replace current 'default' JDK
1279%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1280
1281%buildrequires_jdk BuildRequires: %required_jdk
1282
1283%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1284
e0e23dcd 1285%_javasrcdir %{_usrsrc}/java
1286
a9254650 1287%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1288%jar %{java_home}/bin/jar
ed644e79 1289%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
fe6c4bdd
ER
1290%javac %{java_home}/bin/javac
1291%javadoc %{java_home}/bin/javadoc
6aedae62 1292
fe6c4bdd 1293%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1294
1295%jpackage_script() \
3ca65b87
ER
1296install -d $RPM_BUILD_ROOT%{_bindir}\
1297cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1298#!/bin/sh\
1299#\
1300# %{name} script\
1301# JPackage Project <http://www.jpackage.org/>\
1302\
1303# Source functions library\
1304. %{_javadir}-utils/java-functions\
1305\
1306# Source system prefs\
3ca65b87 1307if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1308 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1309fi\
1310\
1311# Source user prefs\
3ca65b87
ER
1312if [ -f $HOME/.%{name}rc ]; then\
1313 . $HOME/.%{name}rc\
6aedae62
ER
1314fi\
1315\
1316# Configuration\
1317MAIN_CLASS=%1\
1318BASE_FLAGS=%2\
1319BASE_OPTIONS=%3\
3ca65b87 1320BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1321\
1322# Set parameters\
1323set_jvm\
3ca65b87
ER
1324set_classpath $BASE_JARS\
1325set_flags $BASE_FLAGS\
1326set_options $BASE_OPTIONS\
6aedae62
ER
1327\
1328# Let's start\
3ca65b87 1329run "$@"\
6aedae62
ER
1330EOF
1331
06f11871
ER
1332# jpackage 1.7
1333# Directory for maven depmaps
1334#
1335%_mavendepmapdir /etc/maven
1336%_mavendepmapfragdir /etc/maven/fragments
1337
1338#
1339# add_to_depmap adds an entry to the depmap. The arguments are:
1340#
1341# %1 the original groupid
1342# %2 the original artifact id
1343# %3 the version
1344# %4 the new groupid
1345# %5 the new artifactid
1346#
1347
1348%add_to_maven_depmap() \
1349install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1350cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1351<dependency>\
1352 <maven>\
1353 <groupId>%1</groupId>\
1354 <artifactId>%2</artifactId>\
1355 <version>%3</version>\
1356 </maven>\
1357 <jpp>\
1358 <groupId>%4</groupId>\
1359 <artifactId>%5</artifactId>\
1360 <version>%3</version>\
1361 </jpp>\
1362</dependency>\
1363\
1364EOF\
1365%{nil}
1366
1367#==============================================================================
1368#
1369# update_maven_depmap updates the main maven depmap
1370#
1371%update_maven_depmap() \
1372echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1373if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1374cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1375fi\
1376echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1377
02c5f99a 1378# JAVA macros specific for PLD
1379
1380# Directory for tomcat context configuration files
1381%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1382
89c2423f 1383# Tomcat cache path
1384%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1385
1386# Clear tomcat cache
1387# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1388#
1389# Usage:
1390# %%tomcat_clear_cache appname
1391#
e09b1b1b 1392# Call this script in %postun scriptlet. It will remove compiled jsps related to
89c2423f 1393# given app.
1394#
1395%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1396
59d3ebe9 1397# PEAR install macros
4c73bc69 1398# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1399#
1400# Usage:
f7ecf326 1401# %%pear_package_setup ...
dfce8b19 1402#
59d3ebe9 1403# -a # - also unpack SOURCE#. for PEAR bootstrapping
43d992d6 1404# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
59d3ebe9 1405# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1406# -D - pass -D to %setup (so the build dir is not removed)
1407# -c - register channel from local channel.xml file
11a40e7b 1408# -d - pass -d arg to pearcmd
dfce8b19
ER
1409#
1410# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1411# destination hierarchy. you should copy the tree to buildroot after
1412# patching/reorganizing with %%pear_package_install.
1413#
1414# additionally BUILDROOT is stripped from files and files are converted to UNIX
1415# line endings.
1416#
1417# the pear install process output is recorded to install.log, you should put it
8763f51e 1418# to %%doc for later debug or just for information.
dfce8b19
ER
1419#
1420# additionally additional-packages.txt is produced if it was detected that the
1421# package has optional dependencies. the file format is suitable of displaying
1422# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1423# automatically added for this file.
59d3ebe9
ER
1424
1425
1426# records install.log and transforms PEAR names to PLD Linux rpm package names.
1427%__pear_install_log \
1428tee install.log \
1429# make post message of optional packages \
5ad4663a 1430grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1431if [ -s optional-packages.txt ]; then \
1432 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1433else \
1434 rm -f optional-packages.txt \
1435fi \
1436%{nil}
1437
e98e79d4
ER
1438# Command invoking PEAR CLI
1439# Same as /usr/bin/pear, except we force GMT timezone
1440%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
59d3ebe9 1441
11a40e7b 1442%pear_install(a:d:n:zD) \
59d3ebe9 1443%__pear \\\
f7ecf326 1444 -c %{builddir}/pearrc \\\
dfce8b19 1445 -d doc_dir=/docs \\\
f7ecf326
ER
1446 -d temp_dir=/tmp \\\
1447 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1448 -d bin_dir=%{_bindir} \\\
1449 -d data_dir=%{php_pear_dir}/data \\\
1450 -d test_dir=%{php_pear_dir}/tests \\\
11a40e7b 1451 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
dfce8b19 1452 install \\\
59d3ebe9 1453 --packagingroot=%{builddir} \\\
dfce8b19
ER
1454 --offline \\\
1455 --nodeps \\\
1456 %{-f:--force} \\\
67a089ff 1457 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1458 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1459%{nil}
1460
1461# The main macro.
1462# using this macro will append optional-packages.txt to the nocompressdoc list
1463# as it's displayed to user after package install. and adding additional gzip
1464# dep is just waste ;)
11a40e7b 1465%pear_package_setup(a:d:n:zDc:) \
43d992d6 1466%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
67a089ff
ER
1467%define builddir %{_builddir}/%{srcdir} \
1468%setup -q -c -T %{-D:-D} -n %{srcdir} \
a4b4c90f 1469%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
67a089ff 1470%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1471%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1472%pear_install \
59d3ebe9 1473%{-z:cd ..} \
a4b4c90f 1474%{__tar} --wildcards -zvxf %{S:0} package*.xml \
59d3ebe9 1475cat %{-z:$_N/}.install.log | %__pear_install_log \
208a11f6 1476%undos -f php,html,js,xml \
dfce8b19
ER
1477%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1478%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1479%{nil}
1480
c732ab20 1481# Copies extracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1482# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1483%pear_package_install() \
1484cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
c732ab20 1485# tests should not be packaged \
d316604f 1486%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
c732ab20 1487# cleanup backups \
dfce8b19
ER
1488find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1489# help the developer out a little: \
1490if [ -f _noautoreq ]; then \
1491 echo "AutoReqdep detected:" \
1492 echo "_noautoreq $(cat _noautoreq)" \
1493fi \
1494%{nil}
1495
cc8d4be7
ER
1496# Print optional package info for pear packages
1497# Author: Elan Ruusamäe <glen@pld-linux.org>
1498# Usage:
1499# %post -p <lua>
1500# %%pear_package_print_optionalpackages
1501#
1502# Requirements:
1503# BuildRequires: rpmbuild(macros) >= 1.571
1504%pear_package_print_optionalpackages \
1505f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1506if f then \
1507 for l in f:lines() do print(l); end \
1508end \
1509%{nil}
1510
0d5dd00c
ER
1511
1512# Register OpenLDAP schema.
4c73bc69 1513# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1514#
1515# Usage:
1516# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1517#
1518# -d specify dependant schemas, separated by comma
1519#
1520%openldap_schema_register(d:) \
1521for schema in %*; do \
1522 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1523 %{__sed} -i -e " \
1524 /^include.*local.schema/{ \
1525 iinclude\\t $schema\
1526 } \
1527 " /etc/openldap/slapd.conf \
1528 fi \
1529done \
1530# enable dependant schemas \
1531if [ "%{-d*}" ]; then \
1532 %{__sed} -i -e ' \
1533 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1534 s/^#// \
1535 }' /etc/openldap/slapd.conf \
1536fi \
1537%{nil}
1538
1539# Unregister OpenLDAP schema.
4c73bc69 1540# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1541#
1542# Usage:
1543# %%openldap_schema_unregister %{schemadir}/horde.schema
1544#
1545%openldap_schema_unregister() \
1546for schema in %*; do \
1547 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1548 %{__sed} -i -e " \
1549 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1550 # for symmetry it would be nice if we disable enabled schemas in post, \
1551 # but we really can not do that, it would break something else. \
1552 " /etc/openldap/slapd.conf \
1553 fi \
1554done \
1555%{nil}
1556
b0bc2936 1557%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1558
dcc6baf7 1559
1560# Build modules for kernels 2.6
1561# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1562#
1563# Usage:
aa559e46 1564# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1565#
1566# remember that proper Makefile is still required
1567# Options:
990bd03f 1568# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1569# without .ko extension, may be placed in subdirectory
aa559e46 1570# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1571# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1572# -c -- do not execute make clean
dcc6baf7 1573# <additional arguments> -- all additional arguments will be passed to
1574# make modules
1575#
1576# Additional patching supported via here document. Try:
1577# %build_kernel_modules -m module <<'EOF'
1578# your patch script here
1579# EOF
1580# Don't use it unless patching depends on config options.
1581
1582# Developer note: don't touch it unless you know how to handle '\'.
1583# - \ in script expands to nothing
1584# - \\\ in script expands to \
566398b4 1585# - \\\ inside definition expands to nothing
dcc6baf7 1586# - \\\\\\\ inside definition expands to \
1587# - in last line \ has to touch arguments so arguments passing
1588# in new lines (using \) will be supported
1589
5a81d83e 1590%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1591%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1592 \
1593%define Opts \\\\\\\
1594%if "%{_target_base_arch}" != "%{_arch}" \\\
1595 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1596 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1597 %else \\\
1598 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1599 %endif \\\
1600%else \\\
88608ef7 1601 CC="%{kgcc}" \\\
dcc6baf7 1602%endif \
88608ef7 1603%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1604 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1605 \
e364bc26 1606%{?-C:cd %{-C*}} \
dcc6baf7 1607compile() { \
ba9de9b2
ER
1608 local L="<" PATCH_SH; \
1609 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1610 set -e -x \
730239f9 1611 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1612 \
730239f9 1613for cfg in ${cfgs:-dist}; do \
dcc6baf7 1614 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1615 \
c546f6fb 1616 rm -rf o \
ec8cb195 1617 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
dcc6baf7 1618 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1619 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
ec8cb195
AM
1620 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1621 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
a2a36b0c 1622 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
ec8cb195
AM
1623 else \
1624 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1625 fi \
dcc6baf7 1626 \
1627 set +x \
1628 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1629 set -x \
1630 \
c768535c 1631 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1632 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1633 %{-p*} %{-P*} \\\
1634 %{MakeOpts} \
1635 %else \
1636 install -d o/include/config \
1637 touch o/include/config/MARKER \
588f1b0b 1638 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1639 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1640 %endif \
1641 \
5a81d83e 1642 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1643 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1644 ${1+"$@"} \\\
5a81d83e 1645 M=$PWD %{MakeOpts}} \
f635907b 1646 \
dcc6baf7 1647 %{__make} -C %{_kernelsrcdir} modules \\\
1648 ${1+"$@"} \\\
1649 M=$PWD %{MakeOpts} \
1650 \
1651 for MODULE in {%{-m*},}; do \
1652 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1653 done \
1654done \
aa559e46 1655%{?-C:cd -} \
dcc6baf7 1656} \
1657compile %{*}\
1658%{nil}
1659
1660
1661# Install kernel modules built by %build_kernel_modules
1662# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1663#
1664# Usage:
1665# %install_kernel_modules -m <modules> -d <directory>
1666#
1667# Options:
990bd03f 1668# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1669# without .ko extension, may be placed in subdirectory
1670# -d <directory> (required) -- in what subdirectory modules should be
1671# installed (eg. misc, kernel/drivers/net)
1672# -s <suffix> -- suffix to use when installing modules, useful when module
1673# with same name exists in kernel already
1674# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1675# for defining aliases, only useful with -s
dcc6baf7 1676
1677%install_kernel_modules(m:d:s:n:) \
1678%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1679%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1680%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1681 \
1682%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1683%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1684 \
b279feda 1685__install_kernel_modules() { \
730239f9 1686local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1687 \
1688for MODULE in {%{-m*},}; do \
1689 [ -n "${MODULE}" ] || continue \
730239f9
ER
1690 for cfg in ${cfgs:-dist}; do \
1691 [ "$cfg" = smp ] && suf=smp || suf= \
1692 MNAME=${MODULE##*/} \
1693 install -D ${MODULE}-$cfg.ko \\\
1694 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1695 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1696 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1697 >> %{ModprobeD}$suf/%{-n*}.conf} \
1698 done \
dcc6baf7 1699done \
b279feda 1700} \
1701__install_kernel_modules \
dcc6baf7 1702%{nil}
1703
fa65356c 1704# patchset macros
4c73bc69 1705# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1706#
1707# Usage:
1708# %patchset_source -f <seq(1) format> <start> [<end>]
1709# %patchset_patch <start> [<end>]
1710#
1711# If <end> is omited, it is assumed to be <start>.
1712#
1713# For example in preamble:
1714# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1715# and in %prep:
1716# %patchset_patch 33 44
1717
1718# generate SourceX urls from range START STOP
1719# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1720# The sources start from 10000
e91610db 1721%patchset_source(f:b:) %(
44f733ef 1722 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1723 start=$(expr $base + %1);
1724 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1725 # we need to call seq twice as it doesn't allow two formats
1726 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1727 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1728 paste %{tmpdir}/__ps{1,2};
1729 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1730) \
1731%{nil}
fa65356c
ER
1732
1733# apply sources from %patchset_source
1734# -p specify -pX for %patch line
1735# -b base offset: defaults to 10000
1736%patchset_patch(f:p:b:) %(
44f733ef 1737 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1738 start=$(expr $base + %1);
1739 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1740 echo ": patchset_patch %1%{?2: to %2}";
1741 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1742) \
1743%{nil}
fa65356c 1744
5730b44b 1745# browser plugins v2
4c73bc69 1746# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1747#
1748# Usage:
1749# %browser_plugins_add_browser <name> -p <plugindir>
1750#
1751# <name> (required) -- name of the browser. usually %{name}.
1752# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1753# -b -- default blacklists
1754# -a <arch> override arch
5730b44b
ER
1755#
1756# Example:
1757# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1758
1759%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1760%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1761%update_browser_plugins /usr/sbin/update-browser-plugins || :
1762
02ebf70f 1763%browser_plugins_add_browser(p:b:a:) \
9efd458e 1764 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1765 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1766 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1767 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1768 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1769 %{-b:cat >> $blacklist_file %{-b*}} \
1770%{nil}
1771
ad17b654
ER
1772# Helper for LUA.
1773# split string separated by space into quoted list
1774#
4c73bc69 1775# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1776#
1777# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1778%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1779
1780# adjust /etc/shells by adding and removing shells from there
4c73bc69 1781# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1782#
1783# Usage:
d9b789d9
ER
1784# %post -p <lua>
1785# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1786#
d9b789d9
ER
1787# %preun -p <lua>
1788# if arg[2] == 0 then
1789# %lua_remove_etc_shells /bin/bash /bin/rbash
1790# end
7377b5ca
ER
1791#
1792# Requirements:
d9b789d9
ER
1793# BuildRequires: rpmbuild(macros) >= 1.462
1794#
ad17b654 1795
d9b789d9 1796%lua_add_etc_shells() \
ad17b654
ER
1797t = {}\
1798f = io.open("/etc/shells", "r")\
1799if f then\
1800 for l in f:lines() do t[l]=l; end\
1801 f:close()\
1802end\
1803for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1804 if not t[s] then\
b8c0bc18 1805 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1806 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1807 end\
1808end\
1809%{nil}
1810
d9b789d9
ER
1811%lua_remove_etc_shells() \
1812t = {}\
1813f = io.open("/etc/shells", "r")\
1814if f then\
1815 for l in f:lines() do t[l]=l; end\
1816 f:close()\
1817end\
1818for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1819 print("Removing "..l.." from /etc/shells")\
1820 t[l] = nil\
1821end\
1822s=""\
1823for _, l in pairs(t) do\
1824 s=s..l.."\\n"\
1825end\
1826io.open("/etc/shells", "w"):write(s)\
1827%{nil}
1828
1829# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1830#
1831# Author: Elan Ruusamäe <glen@pld-linux.org>
1832#
1833# Usage:
1834# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1835# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1836#
1837# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1838#
1839# Requirements:
1840# BuildRequires: rpmbuild(macros) >= 1.429
1841#
1842%add_etc_shells(p) %{-p:<lua>}\
1843%{expand:%%lua_add_etc_shells %*}\
1844%{nil}
1845
ad17b654 1846%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1847%{-p:if arg[2] == 0 then}\
d9b789d9 1848%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1849%{-p:end} \
ad17b654
ER
1850%{nil}
1851
75bd6249
ER
1852# Check syntax for Python files
1853#
1854# Author: Elan Ruusamäe <glen@pld-linux.org>
1855# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1856#
1857# Usage:
1858# %py_lint src
1859#
1860# Requirements:
1861# BuildRequires: python
1862# BuildRequires: rpmbuild(macros) >= 1.469
1863
1864%py_lint() \
1865__py_lint() { \
1866find "$@" -type f -name '*.py' | python -c ' \
1867import sys \
1868import compiler \
1869\
1870err = 0\
1871for f in sys.stdin: \
1872 fd = open(f.strip()) \
1873 c = fd.read() \
1874 fd.close() \
1875 try: \
1876 compiler.parse(c) \
1877 except SyntaxError, e: \
1878 print "py_lint: %s: %s" % (f.strip(), e) \
1879 err = err + 1\
1880\
1881if err: \
1882 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1883 sys.exit(1) \
1884else: \
1885 print >> sys.stderr, "py_lint: Found no syntax errors." \
1886' \
1887}; __py_lint %* \
1888%{nil}
1889
f602e4a0 1890# Undos files
1891#
1892# Author: Paweł Zuzelski <pawelz@pld-linux.org>
0217c63b 1893# Author: Elan Ruusamäe <glen@pld-linux.org>
f602e4a0 1894#
1895# Usage:
1896# %undos list_of_files
0217c63b
ER
1897# %undos -f EXT[,EXT]
1898# %undos -i -f EXT[,EXT]
1899#
1900# -f EXT[,EXT] - find(1) files by extensions
1901# -i - case insensitive file search
1902#
1903# Example:
1904# Un-DOS all *.js, *.css files
1905# %undos -f js,css
1906# Un-DOS all *.js, *.JS files
1907# %undos -f js -i
1908# undos all Makefiles
1909# %{__find} -name Makefile | xargs %undos
f602e4a0 1910#
1911# Requirements:
1912# BuildRequires: sed >= 4.0
81a64c94 1913# BuildRequires: rpmbuild(macros) >= 1.565
f602e4a0 1914
0217c63b 1915# NB: make sure this macro stays on one line
81a64c94
ER
1916# NB: make sure it includes newline escape
1917%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1918%{nil}
f602e4a0 1919
2f79ae5a
ER
1920# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1921#
1922# Author: Elan Ruusamäe <glen@pld-linux.org>
1923#
1924# Usage:
1925# -a NAME -- add command named NAME
1926# -d NAME -- remove command named NAME
1927# -f FILE -- specify plugin configuration FILE to extract command definition from
1928#
1929# Sample:
1930# %triggerin -- nagios-nrpe
1931# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1932#
1933# %triggerun -- nagios-nrpe
1934# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1935#
1936# Requirements:
f236a3c2 1937# Requires: grep
1938# Requires: sed >= 4.0
d7cee36f 1939# BuildRequires: rpmbuild(macros) >= 1.552
2f79ae5a 1940%nagios_nrpe(a:d:c:f:) {\
d7cee36f 1941 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2f79ae5a 1942 %{-a:# on -a and config exists \
d7cee36f
ER
1943 if [ -f /etc/nagios/nrpe.cfg ]; then \
1944 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1945 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2f79ae5a
ER
1946 fi; \
1947 fi;} \
1948 %{-d:# on package remove, -d and config exists \
d7cee36f
ER
1949 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1950 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2f79ae5a 1951 fi;} \
d7cee36f
ER
1952 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1953 %service -q nrpe restart; \
1954 fi; \
2f79ae5a
ER
1955}%{nil}
1956
070aa9f4
ER
1957# Import or update Cacti template.
1958#
1959# Author: Elan Ruusamäe <glen@pld-linux.org>
1960#
1961# Usage:
1962# %cacti_import_template XMLFILE
1963# XMLFILE -- XML template to import
1964#
1965# Sample:
1966# %post
1967# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1968#
1969# Requires: cacti >= 0.8.7e-8
1970# BuildRequires: rpmbuild(macros) >= 1.554
1971
1972%cacti_import_template() {\
1973/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1974}%{nil}
1975
cdb82983
JK
1976# pre/post script for -upstart subpackages
1977#
1978# Author: Jacek Konieczny <jajcus@jajcus.net>
1979#
1980# Usage:
1981# %upstart_post service_name
1982# %upstart_postun service_name
1983#
1984# Sample:
1985# %post upstart
1986# %upstart_post %{name}
1987#
1988# %postun upstart
1989# %upstart_postun %{name}
1990#
1991# Requirements:
1992# BuildRequires: rpmbuild(macros) >= 1.560
1993# Requires: rc-scripts >= 0.4.3
1994
1995# migrate from init script to upstart job
c4c1a53f 1996%upstart_post() \
d70efb72
ER
1997 if [ -f /var/lock/subsys/%1 ]; then \
1998 /sbin/service --no-upstart %1 stop \
1999 /sbin/service %1 start \
cdb82983
JK
2000 fi
2001
2002# restart the job after upgrade or migrate to init script on removal
2003# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2004# at this point
c4c1a53f 2005%upstart_postun() \
d70efb72
ER
2006 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2007 /sbin/initctl stop %1 >/dev/null 2>&1 \
2008 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
cdb82983
JK
2009 fi
2010
7982022e 2011# EOF
This page took 0.515732 seconds and 4 git commands to generate.